package coin

import (
	"context"
	"github.com/pkg/errors"
	"live-service/app/user_center/rpc/internal/common/coin_manager"
	"live-service/common/nerr"

	"live-service/app/user_center/rpc/internal/svc"
	"live-service/app/user_center/rpc/pb"

	"github.com/zeromicro/go-zero/core/logx"
)

type ChangeCoinLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewChangeCoinLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ChangeCoinLogic {
	return &ChangeCoinLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// changeCoin 新增或扣减用户弹币
func (l *ChangeCoinLogic) ChangeCoin(in *pb.ChangeCoinReq) (*pb.Empty, error) {
	_, err := l.svcCtx.CoinManager.ChangeCoin(l.ctx, nil, &coin_manager.ChangeCoinReq{
		BattleId: in.BattleId,
		UserId:   in.UserId,
		Change:   in.Change,
	}, in.Reason)
	if err != nil {
		return nil, errors.Wrapf(nerr.NewWithErr(err), "记录弹币失败, err:%+v", err)
	}

	return &pb.Empty{}, nil
}
