package coin

import (
	"bufio"
	"context"
	"fmt"
	"github.com/shopspring/decimal"
	"gorm.io/driver/mysql"
	"gorm.io/gorm"
	"gorm.io/gorm/logger"
	"live-service/app/user_center/model"
	"log"
	"os"
	"regexp"
	"strconv"
	"strings"
	"testing"
	"time"
)

func TestA(t *testing.T) {
	file, err := os.Open("C:\\Users\\NorthLan\\Desktop\\dmgame v3\\6月.txt")
	if err != nil {
		fmt.Println("读取文件失败")
		return
	}
	defer file.Close()

	regex, _ := regexp.Compile(`\d+`)

	type db struct {
		name  string
		value int64
	}
	jfs := make([]db, 0)

	scanner := bufio.NewScanner(file)
	l := 0

	var tmpJ db
	for scanner.Scan() {
		l++
		line := scanner.Text()
		if l == 3 {
			// 名字
			tmpJ.name = strings.TrimSpace(line)
		} else if l == 4 {
			// 电池
			battery, _ := strconv.ParseInt(regex.FindString(line), 10, 0)
			tmpJ.value = battery
			jfs = append(jfs, tmpJ)
			//fmt.Println(battery)
			l = 0
		}
	}
	gormDb, err := gorm.Open(mysql.Open("root:root@tcp(127.0.0.1:3306)/dmgame-dev?charset=utf8mb4&loc=Asia%2FShanghai&parseTime=true"), &gorm.Config{
		Logger: logger.New(
			log.New(os.Stdout, "\r\n", log.LstdFlags),
			logger.Config{
				SlowThreshold:             5 * time.Second,
				LogLevel:                  logger.Info,
				IgnoreRecordNotFoundError: true,
				Colorful:                  true,
			},
		),
	})
	//UserPlatformModel := model.NewUserPlatformModel(gormDb)
	//UserIntegralModel := model.NewUserIntegralModel(gormDb)
	UserCoinModel := model.NewUserCoinModel(gormDb)

	gormDb.Transaction(func(tx *gorm.DB) error {
		for _, tmpJ := range jfs {
			var userId int64
			if err := tx.Table("user_platform").
				Select("user_id").
				Where("p_uname = ?", tmpJ.name).Take(&userId).Error; err != nil {
				continue
			}
			//fmt.Println(userId)

			UserCoinModel.ChangeCoin(context.Background(), tx, userId, tmpJ.value, false)

			//tx.Table("user_integral").
			//	Where("user_id = ?", userId).
			//	Update("integral", gorm.Expr("integral + ?", tmpJ.integral))
		}
		return nil
	})

	if err := scanner.Err(); err != nil {
		fmt.Println("err", err)
	}
}

func TestB(t *testing.T) {
	gormDb, _ := gorm.Open(mysql.Open("root:root@tcp(127.0.0.1:3306)/dmgame-dev?charset=utf8mb4&loc=Asia%2FShanghai&parseTime=true"), &gorm.Config{
		Logger: logger.New(
			log.New(os.Stdout, "\r\n", log.LstdFlags),
			logger.Config{
				SlowThreshold:             5 * time.Second,
				LogLevel:                  logger.Info,
				IgnoreRecordNotFoundError: true,
				Colorful:                  true,
			},
		),
	})
	//UserPlatformModel := model.NewUserPlatformModel(gormDb)
	UserIntegralModel := model.NewUserIntegralModel(gormDb)
	//UserCoinModel := model.NewUserCoinModel(gormDb)

	ctx := context.Background()

	var allCoin []model.UserCoin
	err := gormDb.Model(&model.UserCoin{}).Find(&allCoin).Error
	if err != nil {
		panic(err)
	}

	err = gormDb.Transaction(func(tx *gorm.DB) error {
		for _, coin := range allCoin {
			_, err := UserIntegralModel.ChangeIntegral(ctx, tx, coin.UserId, -coin.Coin*100, true)
			if err != nil {
				return err
			}
			time.Sleep(10 * time.Millisecond)
		}
		return nil
	})
	if err != nil {
		panic(err)
	}
}

func TestC(t *testing.T) {
	gormDb, _ := gorm.Open(mysql.Open("root:root@tcp(127.0.0.1:3306)/dmgame-dev?charset=utf8mb4&loc=Asia%2FShanghai&parseTime=true"), &gorm.Config{
		Logger: logger.New(
			log.New(os.Stdout, "\r\n", log.LstdFlags),
			logger.Config{
				SlowThreshold:             5 * time.Second,
				LogLevel:                  logger.Info,
				IgnoreRecordNotFoundError: true,
				Colorful:                  true,
			},
		),
	})
	//UserPlatformModel := model.NewUserPlatformModel(gormDb)
	//UserIntegralModel := model.NewUserIntegralModel(gormDb)
	UserCoinModel := model.NewUserCoinModel(gormDb)

	ctx := context.Background()

	var allIntegral []model.UserIntegral
	err := gormDb.Model(&model.UserIntegral{}).Find(&allIntegral).Error
	if err != nil {
		panic(err)
	}

	err = gormDb.Transaction(func(tx *gorm.DB) error {
		for _, integral := range allIntegral {
			change := decimal.NewFromInt(integral.Integral).Div(decimal.NewFromInt(500)).Round(0).IntPart()
			_, err := UserCoinModel.ChangeCoin(ctx, tx, integral.UserId, change, true)
			if err != nil {
				return err
			}
			//time.Sleep(10 * time.Millisecond)
		}
		return nil
	})
	if err != nil {
		panic(err)
	}
}
